Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7576)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7709)
@@ -2304,34 +2405,237 @@
 !
     IF ( do_irrigation ) THEN
-       DO ig=1,nbpt
-          !
-          IF ((vegtot(ig) .GT. min_sechiba) .AND. (humrel(ig) .LT. un-min_sechiba) .AND. &
-               & (runoff(ig) .LT. min_sechiba) ) THEN
-             
-             irrig_netereq(ig) = (irrigated(ig) / totarea(ig) ) * MAX(zero, transpot_mean(ig) - &
+      DO ig=1,nbpt
+            !It enters to the new irrigation module only if there is an irrigated fraction, if not irrig_netereq = zero for that cell
+            IF ((irrig_frac(ig) .GT. min_sechiba) .AND. .NOT. old_irrig_scheme ) THEN
+
+                  irrig_netereq(ig) = irrig_netereq(ig) + MIN( irrig_dosmax/3600*dt_routing, &
+                                      root_deficit(ig) ) * soiltile(ig, irrig_st) * vegtot(ig)
+                  ! By definition, irrig_dosmax is in kg/m2 of soil tile/hour,dividing by 3600(seconds/hour) * DT_ROUTING  !
+                  ! = kg/m2 of soil tile/(routing timestep)
+                  ! irrig_netereq(kg/m2 of grid cell / routing timstep ) is equal to
+                  ! root_deficit (kg/m2 of soil tile) * soiltile*vegtot (fraction of soil tile at cell level) = kg/m2 of grid cell
+
+                  IF (.NOT. irrigated_soiltile .AND. ( soiltile(ig,irrig_st) .GT. min_sechiba ) .AND. (vegtot(ig) .GT. min_sechiba) ) THEN
+                      ! Irrigated_soiltile asks if there is an independent soil tile for irrigated crops. If not,
+                      ! actual volume calculated for irrig_netereq assumed that the whole SOILTILE was irrigated, but in this case
+                      ! just a fraction of the irrig_st (irrigated soil tile, by default = 3) is actually irrigated,
+                      ! and irrig_netereq needs to be reduced by irrig_frac/( soiltile * vegtot ) (note that it is max = 1 thanks to irrig_frac calculation in l. 424)
+                      ! Demand(ST3)*irrig_frac/(soiltile(3)*vegtot) = irrig_netereq_In_ST3, then
+                      !irrig_netereq_In_ST3 * (soiltile(3)*vegtot) = irrig_netereq at grid scale = Demand(ST3)*irrig_frac.
+                      irrig_netereq(ig) = irrig_netereq(ig) * irrig_frac(ig) / ( soiltile(ig,irrig_st) * vegtot(ig) )
+                      !irrig_netereq = kg/m2 of grid cell
+
+                  ENDIF
+            !Old irrigation scheme as in tag 2.0
+            ELSE IF((vegtot(ig) .GT. min_sechiba) .AND. (humrel(ig) .LT. un-min_sechiba) .AND. &
+                    & (runoff(ig) .LT. min_sechiba) .AND.  old_irrig_scheme) THEN
+
+                  irrig_netereq(ig) = (irrigated(ig) / totarea(ig) ) * MAX(zero, transpot_mean(ig) - &
                   & (precip(ig)+reinfiltration(ig)) )
-             
-          ENDIF
-          !
-          DO ib=1,nbasmax
-             IF ( routing_area(ig,ib) .GT. 0 ) THEN
-             
-                irrig_needs(ig,ib) = irrig_netereq(ig) * routing_area(ig,ib)
-
-                irrig_actual(ig,ib) = MIN(irrig_needs(ig,ib),&
-                     &   stream_reservoir(ig,ib) + fast_reservoir(ig,ib) + slow_reservoir(ig,ib) )
-                
-                slow_reservoir(ig,ib) = MAX(zero, slow_reservoir(ig,ib) + &
-                     & MIN(zero, fast_reservoir(ig,ib) + MIN(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib))))
-
-                fast_reservoir(ig,ib) = MAX( zero, &
-                     &  fast_reservoir(ig,ib) + MIN(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib)))
-
-                stream_reservoir(ig,ib) = MAX(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib) )
-
-                irrig_deficit(ig,ib) = irrig_needs(ig,ib)-irrig_actual(ig,ib)
-
-             ENDIF
-          ENDDO
+
+            ENDIF
+
+            DO ib=1,nbasmax
+                IF ( routing_area(ig,ib) .GT. 0 ) THEN
+
+                    IF (.NOT. old_irrig_scheme .AND. select_source_irrig) THEN
+
+                      ! For   irrig. scheme, available_reserve gives the amount of water available for irrigation in every reservoir
+                      ! --> avail_reserve is a vector of dimension=3, BY DEFINITION i=1 for streamflow, i=2 fast, and i=3 slow reservoir
+
+                      ! The new priorization scheme takes into account irrig. infrastructur according to GMIA map
+                      ! It also withdraw water according to availability, it means that it wont seek for all the water in then
+                      ! stream reservoir, even if this one could respond to the demand by itself
+
+                      pot_slow_wdr_dummy = ( 1 - fraction_aeirrig_sw(ig)) * avail_reserve(3)*slow_reservoir(ig,ib)
+                      pot_fast_wdr_dummy = fraction_aeirrig_sw(ig) * avail_reserve(2)*fast_reservoir(ig,ib)
+                      pot_stre_wdr_dummy = fraction_aeirrig_sw(ig) * avail_reserve(1) * stream_reservoir(ig,ib)
+                      pcent_vol_irrig = zero
+                      IsFail_slow = .FALSE. !
+                      IsFail_fast = .FALSE. !
+                      IsFail_stre = .FALSE. !
+                      irrig_needs(ig,ib) = irrig_netereq(ig) * routing_area(ig,ib)
+
+                      irrig_actual(ig,ib) = MIN(irrig_needs(ig,ib),&
+                            pot_stre_wdr_dummy + pot_fast_wdr_dummy + pot_slow_wdr_dummy)
+
+                       !!   additional IF to calculate pcent_vol_irrig, in the case the total avail.
+                       !! water is zero, I.E. when there is no water in surface and fraction_ae = 0,
+                       !! so GW is not taken into account
+                       !! Note on pcent_vol_irrig: It correspond to the fraction of available water in surface,
+                       !! considering environmental needs and irrigation equipement by source from map. It controls
+                       !! how the source of water withdrawl, especially when requirements < available water
+
+                      IF (  (pot_stre_wdr_dummy + pot_fast_wdr_dummy + pot_slow_wdr_dummy)  .GT. min_sechiba ) THEN
+
+                          pcent_vol_irrig = ( pot_stre_wdr_dummy + pot_fast_wdr_dummy ) / &
+                                ( pot_stre_wdr_dummy + pot_fast_wdr_dummy + pot_slow_wdr_dummy )
+
+                          !Irrig_actual set to zero, because there is no available water.
+                          !Put to avoid negative values due to problems in the Min function
+                          irrig_actual(ig,ib) = MAX(irrig_actual(ig,ib), zero)
+                      !Already zero because pcent_vol_irrig initialized to zero
+                      !Put here to readability but not necessary
+                      !ELSE
+                      !    pcent_vol_irrig = zero
+
+                      ENDIF
+
+                      !Note for irrig_gw_source(ig): first we add the slow_reservoir volume. Then we substract the updated slow_reservoir. It should be the
+                      !Volume used for irrigation that comes from GW
+                      ! Idem for irrig_fast_source and irrig_str_source
+
+                      slow_wdr_dummy = slow_reservoir(ig,ib)
+                      slow_reservoir(ig,ib) = MAX( (un - ( un - fraction_aeirrig_sw(ig) ) * avail_reserve(3) ) * &
+                                              slow_reservoir(ig,ib), slow_reservoir(ig,ib) + &
+                                              MIN( - irrig_actual(ig,ib) * (un - pcent_vol_irrig ), &
+                                              avail_reserve(2) * fraction_aeirrig_sw(ig) * fast_reservoir(ig,ib) + &
+                                              MIN(zero, avail_reserve(1) * fraction_aeirrig_sw(ig) * stream_reservoir(ig,ib)  - &
+                                              pcent_vol_irrig * irrig_actual(ig,ib) ) ) )
+
+                      slow_wdr_dummy = slow_wdr_dummy - slow_reservoir(ig,ib)
+                      irrig_gw_source(ig) = irrig_gw_source(ig) + slow_wdr_dummy
+
+                      fast_wdr_dummy = fast_reservoir(ig,ib)
+                      fast_reservoir(ig,ib) = MAX( (un - avail_reserve(2) * fraction_aeirrig_sw(ig) ) * fast_reservoir(ig,ib) , &
+                                              fast_reservoir(ig,ib) + MIN(zero, avail_reserve(1) * fraction_aeirrig_sw(ig) * stream_reservoir(ig,ib)  - &
+                                              pcent_vol_irrig * irrig_actual(ig,ib) ) )
+                      fast_wdr_dummy = fast_wdr_dummy - fast_reservoir(ig,ib)
+                      irrig_fast_source(ig) = irrig_fast_source(ig) + fast_wdr_dummy
+
+                      stre_wdr_dummy = stream_reservoir(ig,ib)
+                      stream_reservoir(ig,ib) = MAX((un - avail_reserve(1)* fraction_aeirrig_sw(ig) )*stream_reservoir(ig,ib), &
+                                                stream_reservoir(ig,ib)  - &
+                                                pcent_vol_irrig * irrig_actual(ig,ib) )
+                      stre_wdr_dummy = stre_wdr_dummy - stream_reservoir(ig,ib)
+                      irrig_str_source(ig) = irrig_str_source(ig) + stre_wdr_dummy
+
+                      irrig_deficit(ig,ib) = irrig_needs(ig,ib)-irrig_actual(ig,ib)
+
+                      !A reservoir is failing to give water for infiltration if pot. req > pot. withdrawal
+                      !We assume that the pot. requirement = Needs * fraction of area equipped for SW/GW
+                      !In the case of surface. we also sustract the withdrawal from Fast/Stream, because both are
+                      !  considered as surface water
+                      IsFail_slow = ( ( irrig_needs(ig,ib)*(un - fraction_aeirrig_sw(ig)) ) > pot_slow_wdr_dummy )
+                      IsFail_fast = ( ( irrig_needs(ig,ib)*fraction_aeirrig_sw(ig) - stre_wdr_dummy ) > pot_fast_wdr_dummy )
+                      IsFail_stre = ( ( irrig_needs(ig,ib)*fraction_aeirrig_sw(ig) - fast_wdr_dummy ) > pot_stre_wdr_dummy )
+
+                      IF( IsFail_stre ) THEN
+                        Count_failure_stre(ig) = un
+                      ENDIF
+                      IF( IsFail_fast ) THEN
+                        Count_failure_fast(ig) = un
+                      ENDIF
+                      IF( IsFail_slow ) THEN
+                        Count_failure_slow(ig) = un
+                      ENDIF
+
+                    ELSE IF (.NOT. old_irrig_scheme .AND. .NOT. select_source_irrig) THEN
+                        ! For   irrig. scheme, available_reserve gives the amount of water available for irrigation in every reservoir
+                        ! --> avail_reserve is a vector of dimension=3, BY DEFINITION i=1 for streamflow, i=2 fast, and i=3 slow reservoir
+                        irrig_needs(ig,ib) = irrig_netereq(ig) * routing_area(ig,ib)
+
+                        pot_slow_wdr_dummy = avail_reserve(3)*slow_reservoir(ig,ib)
+                        pot_fast_wdr_dummy = avail_reserve(2)*fast_reservoir(ig,ib)
+                        pot_stre_wdr_dummy = avail_reserve(1)*stream_reservoir(ig,ib)
+                        IsFail_slow = .FALSE. !
+                        IsFail_fast = .FALSE. !
+                        IsFail_stre = .FALSE. !
+
+                        irrig_actual(ig,ib) = MIN(irrig_needs(ig,ib),&
+                             & pot_stre_wdr_dummy + pot_fast_wdr_dummy + pot_slow_wdr_dummy )
+
+                        !Note for irrig_gw_source(ig): first we add the slow_reservoir volume. Then we substract the updated slow_reservoir. It should be the
+                        !Volume used for irrigation that comes from GW
+                        ! Idem for irrig_fast_source and irrig_str_source
+                        slow_wdr_dummy = slow_reservoir(ig,ib)
+                        slow_reservoir(ig,ib) = MAX( (1-avail_reserve(3) )*slow_reservoir(ig,ib), slow_reservoir(ig,ib) + &
+                             & MIN(zero, avail_reserve(2)*fast_reservoir(ig,ib) + MIN(zero, avail_reserve(1)*stream_reservoir(ig,ib)-irrig_actual(ig,ib))))
+                        slow_wdr_dummy = slow_wdr_dummy - slow_reservoir(ig,ib)
+                        irrig_gw_source(ig) = irrig_gw_source(ig) + slow_wdr_dummy
+
+                        fast_wdr_dummy = fast_reservoir(ig,ib)
+                        fast_reservoir(ig,ib) = MAX(  (1-avail_reserve(2) )*fast_reservoir(ig,ib) , &
+                             fast_reservoir(ig,ib) + MIN(zero, avail_reserve(1)*stream_reservoir(ig,ib)-irrig_actual(ig,ib)))
+                        fast_wdr_dummy = fast_wdr_dummy - fast_reservoir(ig,ib)
+                        irrig_fast_source(ig) = irrig_fast_source(ig) + fast_wdr_dummy
+
+                        stre_wdr_dummy = stream_reservoir(ig,ib)
+                        stream_reservoir(ig,ib) = MAX( (1-avail_reserve(1) )*stream_reservoir(ig,ib), stream_reservoir(ig,ib)-irrig_actual(ig,ib) )
+                        stre_wdr_dummy = stre_wdr_dummy - stream_reservoir(ig,ib)
+                        irrig_str_source(ig) = irrig_str_source(ig) + stre_wdr_dummy
+
+                        irrig_deficit(ig,ib) = irrig_needs(ig,ib)-irrig_actual(ig,ib)
+                        !A reservoir is failing to give water for infiltration if pot. req > pot. withdrawal
+                        ! Because it follows the old scheme, we do not separate between surface/gw, but consider that
+                        ! priority is given in this order: River, Fast and Slow reservoir.
+                        IsFail_slow = ( ( irrig_needs(ig,ib) - stre_wdr_dummy - fast_wdr_dummy  ) > pot_slow_wdr_dummy )
+                        IsFail_fast = ( ( irrig_needs(ig,ib) - stre_wdr_dummy ) > pot_fast_wdr_dummy )
+                        IsFail_stre = ( irrig_needs(ig,ib) > pot_stre_wdr_dummy )
+
+                        IF( IsFail_stre ) THEN
+                          Count_failure_stre(ig) = un
+                        ENDIF
+                        IF( IsFail_fast ) THEN
+                          Count_failure_fast(ig) = un
+                        ENDIF
+                        IF( IsFail_slow ) THEN
+                          Count_failure_slow(ig) = un
+                        ENDIF
+
+                    ELSE !Old irrigation scheme as in tag 2.0
+                      !Note for irrig_gw_source(ig): first we add the slow_reservoir volume. Then we substract the updated slow_reservoir. It should be the
+                      !Volume used for irrigation that comes from GW
+                      ! Idem for irrig_fast_source and irrig_str_source
+                        irrig_needs(ig,ib) = irrig_netereq(ig) * routing_area(ig,ib)
+
+                        pot_slow_wdr_dummy = slow_reservoir(ig,ib)
+                        pot_fast_wdr_dummy = fast_reservoir(ig,ib)
+                        pot_stre_wdr_dummy = stream_reservoir(ig,ib)
+                        IsFail_slow = .FALSE. !
+                        IsFail_fast = .FALSE. !
+                        IsFail_stre = .FALSE. !
+                        irrig_actual(ig,ib) = MIN(irrig_needs(ig,ib),&
+                             &   stream_reservoir(ig,ib) + fast_reservoir(ig,ib) + slow_reservoir(ig,ib) )
+
+                        slow_wdr_dummy = slow_reservoir(ig,ib)
+                        slow_reservoir(ig,ib) = MAX(zero, slow_reservoir(ig,ib) + &
+                             & MIN(zero, fast_reservoir(ig,ib) + MIN(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib))))
+                        slow_wdr_dummy = slow_wdr_dummy - slow_reservoir(ig,ib)
+                        irrig_gw_source(ig) = irrig_gw_source(ig) + slow_wdr_dummy
+
+                        fast_wdr_dummy = fast_reservoir(ig,ib)
+                        fast_reservoir(ig,ib) = MAX( zero, &
+                             &  fast_reservoir(ig,ib) + MIN(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib)))
+                        fast_wdr_dummy = fast_wdr_dummy - fast_reservoir(ig,ib)
+                        irrig_fast_source(ig) = irrig_fast_source(ig) + fast_wdr_dummy
+
+                        stre_wdr_dummy = stream_reservoir(ig,ib)
+                        stream_reservoir(ig,ib) = MAX(zero, stream_reservoir(ig,ib)-irrig_actual(ig,ib) )
+                        stre_wdr_dummy = stre_wdr_dummy - stream_reservoir(ig,ib)
+                        irrig_str_source(ig) = irrig_str_source(ig) + stre_wdr_dummy
+
+                        irrig_deficit(ig,ib) = irrig_needs(ig,ib)-irrig_actual(ig,ib)
+                        !A reservoir is failing to give water for infiltration if pot. req > pot. withdrawal
+                        ! Because it follows the old scheme, we do not separate between surface/gw, but consider that
+                        ! priority is given in this order: River, Fast and Slow reservoir.
+                        IsFail_slow = ( ( irrig_needs(ig,ib) - stre_wdr_dummy - fast_wdr_dummy  ) > pot_slow_wdr_dummy )
+                        IsFail_fast = ( ( irrig_needs(ig,ib) - stre_wdr_dummy ) > pot_fast_wdr_dummy )
+                        IsFail_stre = ( irrig_needs(ig,ib) > pot_stre_wdr_dummy )
+
+                        IF( IsFail_stre ) THEN
+                          Count_failure_stre(ig) = un
+                        ENDIF
+                        IF( IsFail_fast ) THEN
+                          Count_failure_fast(ig) = un
+                        ENDIF
+                        IF( IsFail_slow ) THEN
+                          Count_failure_slow(ig) = un
+                        ENDIF
+
+                    ENDIF
+
+                ENDIF
+            ENDDO
           !
           ! Check if we cannot find the missing water in another basin of the same grid (stream reservoir only).
@@ -2342,32 +2646,32 @@
 !> in another basin of the same grid. If there is water in the stream reservoir of this subbasin, we create some adduction
 !> from that subbasin to the one where we need it for irrigation.
-!> 
-          DO ib=1,nbasmax
-
-             stream_tot = SUM(stream_reservoir(ig,:))
-
-             DO WHILE ( irrig_deficit(ig,ib) > min_sechiba .AND. stream_tot > min_sechiba)
-                
-                fi = MAXLOC(stream_reservoir(ig,:))
-                ib2 = fi(1)
-
-                irrig_adduct(ig,ib) = MIN(irrig_deficit(ig,ib), stream_reservoir(ig,ib2))
-                stream_reservoir(ig,ib2) = stream_reservoir(ig,ib2)-irrig_adduct(ig,ib)
-                irrig_deficit(ig,ib) = irrig_deficit(ig,ib)-irrig_adduct(ig,ib)
-             
-                stream_tot = SUM(stream_reservoir(ig,:))
-                
-             ENDDO
-             
-          ENDDO
-          !
-       ENDDO
-       !
-       ! If we are at higher resolution we might need to look at neighboring grid boxes to find the streams
-       ! which can feed irrigation
-!
-!> At higher resolution (grid box smaller than 100x100km), we can import water from neighboring grid boxes
-!> to the one where we need it for irrigation.
-       !
+!>
+            DO ib=1,nbasmax
+
+               stream_tot = a_stream_adduction * SUM(stream_reservoir(ig,:))
+
+                 DO WHILE ( irrig_deficit(ig,ib) > min_sechiba .AND. stream_tot > min_sechiba)
+
+                      fi = MAXLOC(stream_reservoir(ig,:))
+                      ib2 = fi(1)
+
+                      irrig_adduct(ig,ib) = MIN(irrig_deficit(ig,ib), a_stream_adduction * stream_reservoir(ig,ib2))
+                      stream_reservoir(ig,ib2) = stream_reservoir(ig,ib2)-irrig_adduct(ig,ib)
+                      irrig_deficit(ig,ib) = irrig_deficit(ig,ib)-irrig_adduct(ig,ib)
+
+                      stream_tot = a_stream_adduction * SUM(stream_reservoir(ig,:))
+
+                 ENDDO
+
+            ENDDO
+          !
+      ENDDO
+      !
+      ! If we are at higher resolution we might need to look at neighboring grid boxes to find the streams
+      ! which can feed irrigation
+      !
+      !> At higher resolution (grid box smaller than 100x100km), we can import water from neighboring grid boxes
+      !> to the one where we need it for irrigation.
+      !
        IF (is_root_prc) THEN
           ALLOCATE(irrig_deficit_glo(nbp_glo, nbasmax), stream_reservoir_glo(nbp_glo, nbasmax), &
@@ -2398,5 +2702,5 @@
                          ig2 = neighbours_g(ig,in)
                          IF (ig2 .GT. 0 ) THEN
-                            streams_around(in,:) = stream_reservoir_glo(ig2,:)
+                            streams_around(in,:) = a_stream_adduction * stream_reservoir_glo(ig2,:)
                             igrd(in) = ig2
                          ENDIF
@@ -2409,6 +2713,6 @@
                          ib2=ff(2)
                          !
-                         IF ( routing_area_glo(ig2,ib2) .GT. 0 .AND. stream_reservoir_glo(ig2,ib2) > zero ) THEN
-                            adduction = MIN(irrig_deficit_glo(ig,ib), stream_reservoir_glo(ig2,ib2))
+                         IF ( routing_area_glo(ig2,ib2) .GT. 0 .AND. a_stream_adduction * stream_reservoir_glo(ig2,ib2) > zero ) THEN
+                            adduction = MIN(irrig_deficit_glo(ig,ib), a_stream_adduction * stream_reservoir_glo(ig2,ib2))
                             stream_reservoir_glo(ig2,ib2) = stream_reservoir_glo(ig2,ib2) - adduction
                             irrig_deficit_glo(ig,ib) = irrig_deficit_glo(ig,ib) - adduction
@@ -2476,4 +2780,6 @@
     pond_diag(:) =  zero
     irrigation(:) = zero
+    irrigdeficit(:) = zero !
+    irrigadduct(:) = zero !
     !
     !
@@ -2482,6 +2788,6 @@
        DO ig=1,nbpt
           IF (hydrodiag(ig,ib) > 0 ) THEN
-             hydrographs(ig) = hydrographs(ig) + fast_flow(ig,ib) + slow_flow(ig,ib) + & 
-                  &  stream_flow(ig,ib) 
+             hydrographs(ig) = hydrographs(ig) + fast_flow(ig,ib) + slow_flow(ig,ib) + &
+                  &  stream_flow(ig,ib)
              slowflow_diag(ig) = slowflow_diag(ig) + slow_flow(ig,ib)
           ENDIF
@@ -2491,4 +2797,6 @@
           flood_diag(ig) = flood_diag(ig) + flood_reservoir(ig,ib)
           irrigation (ig) = irrigation (ig) + irrig_actual(ig,ib) + irrig_adduct(ig,ib)
+          irrigdeficit(ig) = irrigdeficit(ig) + irrig_deficit(ig,ib)!
+          irrigadduct (ig) = irrigadduct (ig) + irrig_adduct(ig,ib)!
        ENDDO
     ENDDO
@@ -2502,6 +2810,12 @@
        !
        irrigation(ig) = irrigation(ig)/totarea(ig)
-       !
-       ! The three output types for the routing : endoheric basins,, rivers and 
+       irrigdeficit(ig) = irrigdeficit(ig)/totarea(ig)!
+       irrigadduct(ig) = irrigadduct(ig)/totarea(ig)!
+       irrig_gw_source(ig) =  irrig_gw_source(ig)/totarea(ig)!
+       irrig_fast_source(ig) =  irrig_fast_source(ig)/totarea(ig)!
+       irrig_str_source(ig) =  irrig_str_source(ig)/totarea(ig)!
+
+       !
+       ! The three output types for the routing : endoheric basins,, rivers and
        ! diffuse coastal flow.
        !
@@ -2513,9 +2827,9 @@
     !
     flood_res = flood_diag + pond_diag
-    
-
-    !! Remove water from lake reservoir if it exceeds the maximum limit and distribute it 
+
+
+    !! Remove water from lake reservoir if it exceeds the maximum limit and distribute it
     !! uniformly over all possible the coastflow gridcells
-    
+
     ! Calculate lake_overflow and remove it from lake_reservoir
     DO ig=1,nbpt
@@ -2541,5 +2855,10 @@
     ! Transform from kg/grid-cell/dt_routing into m^3/grid-cell/s to match output unit of coastalflow
     CALL xios_orchidee_send_field("lake_overflow_coast",lake_overflow_coast/mille/dt_routing)
-   
+
+    ! Counter of reservoir failure to assure irrigation
+    CALL xios_orchidee_send_field("Count_failure_slow", Count_failure_slow)
+    CALL xios_orchidee_send_field("Count_failure_fast", Count_failure_fast)
+    CALL xios_orchidee_send_field("Count_failure_stre", Count_failure_stre)
+
 
   END SUBROUTINE routing_flow
@@ -2590,5 +2909,5 @@
        !
        lake_reservoir(ig) = lake_reservoir(ig) + lakeinflow(ig)
-       
+
        IF ( doswamps ) THEN
           ! Calculate a return flow that will be extracted from the lake reservoir and reinserted in the soil in hydrol
@@ -2635,5 +2954,5 @@
     !
     IMPLICIT NONE
-    
+
 !! INPUT VARIABLES
     INTEGER(i_std), INTENT(in)      :: nbpt               !! Domain size (unitless)
@@ -2652,5 +2971,5 @@
 
 !_ ================================================================================================================================
-    routing_area => routing_area_glo  
+    routing_area => routing_area_glo
     topo_resid => topo_resid_glo
     route_togrid => route_togrid_glo
@@ -2660,8 +2979,8 @@
     hydrodiag=>hydrodiag_glo
     hydroupbasin=>hydroupbasin_glo
-    
+
     IF (is_root_prc) CALL routing_diagnostic(nbp_glo, index_g, lalo_g, resolution_g, contfrac_g, nbrivers_g,basinmap_g)
 
-    routing_area => routing_area_loc  
+    routing_area => routing_area_loc
     topo_resid => topo_resid_loc
     route_togrid => route_togrid_loc
@@ -2671,10 +2990,10 @@
     hydrodiag=>hydrodiag_loc
     hydroupbasin=>hydroupbasin_loc
-    
+
     CALL scatter(nbrivers_g,nbrivers)
     CALL scatter(basinmap_g,basinmap)
     CALL scatter(hydrodiag_glo,hydrodiag_loc)
     CALL scatter(hydroupbasin_glo,hydroupbasin_loc)
-       
+
     CALL xios_orchidee_send_field("basinmap",basinmap)
     CALL xios_orchidee_send_field("nbrivers",nbrivers)
@@ -2692,6 +3011,6 @@
        ENDIF
     ENDIF
-    
-        
+
+
   END SUBROUTINE routing_diagnostic_p
 
@@ -2699,11 +3018,11 @@
 !! SUBROUTINE 	: routing_diagnostic
 !!
-!>\BRIEF         This non-parallelized subroutine gives a diagnostic of the basins used. This produces some information 
+!>\BRIEF         This non-parallelized subroutine gives a diagnostic of the basins used. This produces some information
 !!               on the rivers which are being diagnosed.
 !!
 !! DESCRIPTION (definitions, functional, design, flags) : As not all rivers can be monitored in the model, we will only
 !! archive num_largest rivers. In this routine we will diagnose the num_largest largest rivers and print to the standard
-!! output the names of these basins and their area. The list of names of these largest rivers are taken from a list coded in the 
-!! routine routing_names. As this standard output is not sufficient, we will also write it to a netCDF file with the routine 
+!! output the names of these basins and their area. The list of names of these largest rivers are taken from a list coded in the
+!! routine routing_names. As this standard output is not sufficient, we will also write it to a netCDF file with the routine
 !! routing_diagncfile. It is important to keep for diagnostic the fraction of the largest basins in each grid box and keep information
 !! how they are linked one to the other.
@@ -2726,5 +3045,5 @@
     INTEGER(i_std), INTENT(in)                   :: nbpt                !! Domain size  (unitless)
     INTEGER(i_std), INTENT(in)                   :: l_index(nbpt)       !! Indices of the points on the map (unitless)
-    REAL(r_std), INTENT(in)                      :: lalo(nbpt,2)        !! Vector of latitude and longitudes (beware of the order !) 
+    REAL(r_std), INTENT(in)                      :: lalo(nbpt,2)        !! Vector of latitude and longitudes (beware of the order !)
     REAL(r_std), INTENT(in)                      :: resolution(nbpt,2)  !! The size of each grid box in X and Y (m)
     REAL(r_std), INTENT(in)                      :: contfrac(nbpt)      !! Fraction of land in each grid box (unitless;0-1)
@@ -2741,5 +3060,5 @@
     INTEGER(i_std), ALLOCATABLE, DIMENSION(:)    :: nb_pts              !! Number of points in the basin (unitless)
     REAL(r_std), ALLOCATABLE, DIMENSION(:)       :: totarea             !! Total area of basin (m^2)
-    REAL(r_std), ALLOCATABLE, DIMENSION(:)       :: tmparea             !! 
+    REAL(r_std), ALLOCATABLE, DIMENSION(:)       :: tmparea             !!
     INTEGER(i_std), ALLOCATABLE, DIMENSION(:)    :: topids              !! The IDs of the first num_largest basins (unitless)
     CHARACTER(LEN=25), ALLOCATABLE, DIMENSION(:) :: basin_names         !! Names of the rivers (unitless)
@@ -2818,8 +3137,8 @@
     ALLOCATE(streams_resid(num_largest), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_diagnostic','Pb in allocate for streams_resid','','')
-    
+
     ALLOCATE(lbasin_area(num_largest,nbpt), lbasin_uparea(num_largest,nbpt), lrivercode(num_largest,nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_diagnostic','Pb in allocate for lbasin_area','','')
-    
+
     IF ( .NOT. is_root_prc) THEN
        WRITE(numout,*) "routing_diagnostic is not suitable for running in parallel"
@@ -2828,11 +3147,11 @@
        CALL ipslerr_p(3,'routing_diagnostic','This routine is not suitable for running in parallel','','')
     ENDIF
-    
-    
+
+
     !Config Key   = RIVER_DESC
     !Config Desc  = Writes out a description of the rivers
     !Config If    = RIVER_ROUTING
     !Config Def   = n
-    !Config Help  = This flag allows to write out a file containing the list of 
+    !Config Help  = This flag allows to write out a file containing the list of
     !Config         rivers which are beeing simulated. It provides location of outflow
     !Config         drainage area, name and ID.
@@ -2880,7 +3199,7 @@
        ENDDO
     ENDDO
-    
+
     nb_small = MIN(nb_small, 349)
-    
+
     ALLOCATE(basin_names(nb_small), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_diagnostic','Pb in allocate for basins_names','','')
@@ -2922,5 +3241,5 @@
              longest_river = MAX(longest_river, ic)
              !
-             ! Now that we have an outflow check if it is one of the num_largest rivers. 
+             ! Now that we have an outflow check if it is one of the num_largest rivers.
              ! In this case we keeps the location so we diagnose it.
              !
@@ -3123,5 +3442,5 @@
        tuparea(1:ii) = lbasin_uparea(idbas,1:ii)
        !
-       CALL routing_diagcode(ii, tpts, tptbas, tuparea, tslen, MAXVAL(tslen), allstreams, upstreamchange, tcode)  
+       CALL routing_diagcode(ii, tpts, tptbas, tuparea, tslen, MAXVAL(tslen), allstreams, upstreamchange, tcode)
        !
        lrivercode(idbas,:) = 0
@@ -3178,5 +3497,5 @@
           ENDIF
        ENDDO
-       
+
        IF ( name_found > 1 ) THEN
           DO ic=num_largest,1,-1
@@ -3199,5 +3518,5 @@
           ENDDO
        ENDIF
-       
+
     ENDDO
     !
@@ -3281,5 +3600,5 @@
        WRITE(numout,*) 'Minimum topographic index :', MINVAL(topo_resid, MASK=topo_resid .GT. zero)
     END IF
-    
+
     DEALLOCATE(pts)
     DEALLOCATE(outpt)
@@ -3301,5 +3620,5 @@
        WRITE(numout,*) 'Minimum topographic index :', MINVAL(topo_resid, MASK=topo_resid .GT. 0.)
     END IF
-    
+
   END SUBROUTINE routing_diagnostic
   !
@@ -3308,5 +3627,5 @@
 !!
 !>\BRIEF       This subroutine determines the code in the Pfafstetter system for all points
-!!              within the given catchment.  
+!!              within the given catchment.
 !!
 !! DESCRIPTION (definitions, functional, design, flags) : None
@@ -3322,5 +3641,5 @@
 !_ ================================================================================================================================
 
-  SUBROUTINE routing_diagcode(ip, tpts, tpbas, tuparea, tslen, ls, allstreams, upstreamchange, streamcode)  
+  SUBROUTINE routing_diagcode(ip, tpts, tpbas, tuparea, tslen, ls, allstreams, upstreamchange, streamcode)
     !
     IMPLICIT NONE
@@ -3388,5 +3707,5 @@
              IF ( streamcode(ic) == indsubbas(ib) ) THEN
                 it =it+1
-                iw(it)=ic 
+                iw(it)=ic
              ENDIF
           ENDDO
